## qubes-gui-agent 4.2.7

=== debian/changelog ===
qubes-gui-agent (4.2.7-1+jammy1) jammy; urgency=medium

  * Build for jammy

 -- Builder <user@localhost>  Wed, 17 May 2023 00:05:31 +0200

qubes-gui-agent (4.2.7-1) unstable; urgency=medium

  * deb: Fix clearing source commands

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Wed, 17 May 2023 00:05:31 +0200

=== debian/control ===
Source: qubes-gui-agent
Section: admin
Priority: extra
Maintainer: Qubes OS Team <qubes-devel@googlegroups.com>
Build-Depends:
    debhelper,
    libpam0g-dev,
    libpulse-dev,
    libtool,
    automake,
    xserver-xorg-dev,
    xutils-dev,
    libvchan-dev,
    libx11-dev,
    libgbm-dev,
    libxcomposite-dev,
    libxdamage-dev,
    libxfixes-dev,
    x11proto-xf86dga-dev,
    libxt-dev,
    libxen-dev,
    lsb-release,
    libpipewire-0.3-dev,
    quilt,
    qubes-gui-common (>= 4.1.0),
    qubesdb-dev,
    libltdl-dev,
Standards-Version: 4.4.0.1
Homepage: http://www.qubes-os.org/
#Vcs-Git: git://git.debian.org/collab-maint/qubes-gui-agent.git
#Vcs-Browser: http://git.debian.org/?p=collab-maint/qubes-gui-agent.git;a=summary

Package: qubes-gui-agent
Architecture: any
Depends:
    xserver-xorg-core,
    xinit,
    x11-xserver-utils,
    qubes-core-agent (>= 3.0.14),
    qubesdb-vm (>= 4.1.4),
    libxdamage1,
    libxcomposite1,
    libxfixes3,
    libxt6,
    libx11-6,
    python3,
    python3-xcffib,
    xserver-xorg-video-dummyqbs (= ${binary:Version}),
    xserver-xorg-input-qubes (= ${binary:Version}),
    ${shlibs:Depends},
    ${misc:Depends}
Recommends: qt4-qtconfig, pulseaudio-qubes
Provides: x-display-manager
Description: Makes X11 windows available to qubes dom0
 The Qubes GUI agent allows the forwarding of running app windows to the
 qubes dom0. It also includes various extras such as copy/paste support.

Package: xserver-xorg-qubes-common
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Common functions for qubes xserver driver
 Shared library which contains common functions of the Qubes xserver drivers.

Package: xserver-xorg-video-dummyqbs
Architecture: any
Depends:
 ${xviddriver:Depends},
 ${shlibs:Depends},
 ${misc:Depends},
 xserver-xorg-qubes-common (= ${binary:Version})
Provides:
 ${xviddriver:Provides}
Replaces: qubes-gui-agent (<< 3.2.11-1)
Breaks: qubes-gui-agent (<< 3.2.11-1)
Description: Dummy X video driver for qubes-gui-agent
 Dummy X video driver for Qubes VM, with XRandr support.

Package: xserver-xorg-input-qubes
Architecture: any
Depends:
 ${xinpdriver:Depends},
 ${shlibs:Depends},
 ${misc:Depends},
 xserver-xorg-qubes-common (= ${binary:Version})
Provides:
 ${xinpdriver:Provides}
Replaces: qubes-gui-agent (<< 3.2.11-1)
Breaks: qubes-gui-agent (<< 3.2.11-1)
Description: X input driver for injecting events from qubes-gui-agent
 This driver inject input events delivered through qubes-gui-agent.
 Additionally it helps retrieving composition buffers of windows.

Package: pulseaudio-qubes
Architecture: any
Depends:
    qubesdb-vm (>= 4.1.4),
    pulseaudio,
    libpulse0,
    ${shlibs:Depends},
    ${pulse:Depends},
    ${misc:Depends},
Conflicts: pipewire-qubes
Replaces:
 qubes-gui-agent (<< 4.1.9-1),
 qubes-core-agent (<< 4.2.5-1),
Breaks:
 qubes-gui-agent (<< 4.1.9-1),
 qubes-core-agent (<< 4.2.5-1),
Description: Audio support for Qubes VM
 Pulseaudio module to enable sound support in Qubes VM

Package: pipewire-qubes
Architecture: any
Depends:
 qubesdb-vm (>= 4.1.4),
 ${shlibs:Depends},
 ${misc:Depends}
Conflicts: pulseaudio-qubes
Recommends: pipewire-pulse
Description: PipeWire module to enable sound support in Qubes VM
 Experimental PipeWire module to enable sound support in Qubes VMs.
 Unlike the PulseAudio support in the pulseaudio-qubes package, this
 works with the stock PipeWire service and does not depend on internal
 PipeWire headers.  It is also less code.

Package: qubes-gui-agent-xfce
Architecture: any
Depends:
    ${shlibs:Depends},
    ${misc:Depends}
Description: XFCE desktop support for Qubes VM
 XFCE desktop support for Qubes VM

Package: qubes-gui-vnc
Architecture: any
Depends:
    x11vnc
    ${shlibs:Depends},
    ${misc:Depends}
Description: Remote GuiVM support using VNC
 Remote GuiVM support using VNC

## qubes-gui-agent 4.2.8

=== debian/changelog ===
qubes-gui-agent (4.2.8-1+deb12u1) bookworm; urgency=medium

  * Build for bookworm

 -- Builder <user@localhost>  Fri, 21 Jul 2023 04:25:14 +0200

qubes-gui-agent (4.2.8-1) unstable; urgency=medium

  [ Marek Marczykowski-Górecki ]
  * archlinux: fix install-pipewire call
  * ci: use CI_BRANCH_REF
  * ci: extend exclude list

  [ Augsch123 ]
  * Add libpam-systemd dependency

  [ Demi Marie Obenour ]
  * Switch to protocol 1.4
  * Initial protocol 1.7 support
  * Add a couple of assertions
  * Add simple reference counting of pixmaps
  * Use malloc instead of alloca
  * Support MSG_WINDOW_DUMP_ACK
  * Autotools modernization

  [ Solar Designer ]
  * qubes-keymap.sh: Avoid xkb option accumulation
  * qubes-keymap.sh: Don't add ",us" for layout "si"

  [ Demi Marie Obenour ]
  * Update comment to reflect current GUI agent
  * Increase locked memory limit for "qubes" group
  * Do not hardcode "user" as the GUI user
  * Use set -a instead of sed

  [ Marek Marczykowski-Górecki ]
  * debian: preset user services on pulseaudio-qubes install/uninstall
  * pulseaudio: disable pipewire-pulse too
  * rpm: restore pipewire units on pulseaudio-qubes removal
  * Remove trailing space in 75-pulseaudio-qubes.preset
  * Fix mode of 75-pulseaudio-qubes.preset

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Fri, 21 Jul 2023 04:25:14 +0200

## qubes-gui-agent 4.2.9

=== debian/changelog ===
qubes-gui-agent (4.2.9-1+deb12u1) bookworm; urgency=medium

  * Build for bookworm

 -- Builder <user@localhost>  Sun, 10 Sep 2023 18:25:01 +0200

qubes-gui-agent (4.2.9-1) unstable; urgency=medium

  [ Demi Marie Obenour ]
  * Consolodate gui-common/ and common/ into gui-agent/
  * Ensure that all function declarations have prototypes
  * Fix missing prototypes
  * Update .gitignore files
  * Remove obsolete checks for disposable VM resume
  * Ban old-style declarations and definitions
  * Switch from select(2) to poll(2).
  * Always see if module-vchan-sink.so must be rebuilt
  * fix some clang warnings
  * Avoid reserved identifier violation
  * Fix unchecked malloc()
  * qubes-gui-runuser: obtain default user from qubesdb

  [ Frédéric Pierret (fepitre) ]
  * Update for Fedora 39

  [ fepitre-bot ]
  * Add pulseaudio-16.99.1 headers

  [ Demi Marie Obenour ]
  * Better error checking
  * Add XDG_SESSION_TYPE support
  * Set XDG_SESSION_DESKTOP
  * Protect against more unlikely errors
  * Set XDG_CURRENT_DESKTOP

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sun, 10 Sep 2023 18:25:01 +0200

## qubes-gui-agent 4.2.10

=== debian/changelog ===
qubes-gui-agent (4.2.10-1+deb12u1) bookworm; urgency=medium

  * Build for bookworm

 -- Builder <user@localhost>  Mon, 30 Oct 2023 05:45:06 +0100

qubes-gui-agent (4.2.10-1) unstable; urgency=medium

  [ Everett Gally ]
  * create input device. if fails, will fall back to xdriver. Keyboard
    events are working. Mouse events are not currently. Having trouble
    with getting the cursor into the right position.
  * switched to storing the output_fd and createdInputDevice flag in the
    ghandles
  * added my actual email in the commit so the signature will be
    verified correctly
  * removed a comment from a function that doesn't exist anymore
  * add some log_level checks on some of the fprintf statements I added
  * remove some uneeded whitespace and comments I added previously
  * udev rules file that sets the group owner of the virtual input
    device to user so xinit can access the device when it's created
  * virtual input device disabled by default. Can be enabled by enabling
    the qvm-service 'gui-agent-virtual-input-device'
  * Modifier sync will now happen all the time, regardless of whether
    virtual input device creation was requested or not.
  * removed lines setting bits for EV_REL and the REL_BITS. I'm not
    going to get that in this PR and will work on it in a future one
  * rename output_fd to uinput_fd so it's clearer what the fd is
  * renamed the flag createdInputDevice to created_input_device to
    follow the same naming convention as other variables
  * completely separated original handle_keypress function from the one
    designed for the virtual input device. When input device creation is
    requested, modifier sync now happens through the uinput_fd instead
    of the xserver_fd. All modifiers are working as expected when
    switching between qubes.
  * changed group="user" to group="qubes" in udev rules file. Added
    lines to install the file in Makefile, appvm-
    scripts/lib/udev/rules.d/90-qubes-virtual-input-device.rules,
    debian/qubes-gui-agent.install, and rpm_spec/gui-agent.spec.in
  * made send_event static
  * exclude all BTN_* keys
  * removed some unneeded whitespace
  * an extra unused wait_fds[2] line made it in after the conflict was
    resolved. Removed that line since the variable is unused and stops
    the build
  * fixed caps lock. It was missing the line to flip its bit in last
    known states and needs to be excluded from the key send below
  * remove debug line I added in while testing and forgot to remove in
    the last commit
  * added check to see if modmap is null and moved XFreeModifierMap out
    of the if statement checking if the current keycode is capslock.
  * remove incorrect comment
  * comment explaining why capslock is excluded from key sending

  [ Demi Marie Obenour ]
  * Do not override default clock rate or quantum

  [ Marek Marczykowski-Górecki ]
  * pipewire: adjust buffer parameters

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Mon, 30 Oct 2023 05:45:06 +0100

## qubes-gui-agent 4.2.11

=== pipewire/Makefile ===
extra_cflags := $(shell pkg-config --cflags libpipewire-0.3 vchan-xen) \
  -fno-strict-aliasing -fno-strict-overflow \
  -fno-delete-null-pointer-checks -fPIC -Wall -Wextra -Werror \
  -Wno-missing-field-initializers -Wno-unused-parameter -ggdb -O2
extra_ldflags :=  $(shell pkg-config --libs libpipewire-0.3 vchan-xen) -lqubesdb
CFLAGS += $(extra_cflags)
LDLIBS += $(extra_ldflags)
LDFLAGS += -ggdb -Wl,--no-as-needed,--no-allow-shlib-undefined,-z,relro,-z,now
qubes-pw-module.so: build/qubes-pw-module.o | Makefile
	@mkdir -p -m 0700 -- build
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ -shared $(LDLIBS)

build/%.o: %.c Makefile
	@mkdir -p -m 0700 -- build
	$(CC) $(CPPFLAGS) $(CFLAGS) -c -o $@ $< -MP -MD -MF $@.dep

.PHONY: clean
clean:
	rm -rf -- build
-include build/*.o.dep

=== debian/changelog ===
qubes-gui-agent (4.2.11-1+deb12u1) bookworm; urgency=medium

  * Build for bookworm

 -- Builder <user@localhost>  Mon, 20 Nov 2023 01:46:30 +0100

qubes-gui-agent (4.2.11-1) unstable; urgency=medium

  [ Marek Marczykowski-Górecki ]
  * rpm: fix dist macro usage

  [ Rusty Bird ]
  * vmside: add newline to error messages where it was missing
  * vmside: disambiguate two identical error messages
  * vmside: avoid XGetWindowAttributes() call if result isn't used

  [ Frédéric Pierret (fepitre) ]
  * Add dedicated PAM file for Gentoo

  [ Marek Marczykowski-Górecki ]
  * rpm: adjust dependencies for openSUSE
  * pipewire: skip duplicated cflags
  * rpm: install files to /usr/etc when relevant on openSUSE
  * rpm: adjust directory ownership and add relevant BR to satisfy the
    check
  * Move lightdm.service drop-in into /usr/lib
  * rpm: drop explicit dependency on libXfixes
  * rpm: put PAM config in /usr/lib/pam.d on openSUSE
  * rpm: use fillup tool to manage /etc/sysconfig/desktop on openSUSE

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Mon, 20 Nov 2023 01:46:30 +0100

=== debian/control ===
--- 
+++ 
@@ -43,13 +43,14 @@
     libxfixes3,
     libxt6,
     libx11-6,
+    libpam-systemd,
     python3,
     python3-xcffib,
     xserver-xorg-video-dummyqbs (= ${binary:Version}),
     xserver-xorg-input-qubes (= ${binary:Version}),
     ${shlibs:Depends},
     ${misc:Depends}
-Recommends: qt4-qtconfig, pulseaudio-qubes
+Recommends: qt4-qtconfig, pipewire-qubes
 Provides: x-display-manager
 Description: Makes X11 windows available to qubes dom0
  The Qubes GUI agent allows the forwarding of running app windows to the

## qubes-gui-agent 4.2.12

=== debian/changelog ===
qubes-gui-agent (4.2.12-1+deb13u1) trixie; urgency=medium

  * Build for trixie

 -- Builder <user@localhost>  Wed, 24 Jan 2024 04:03:39 +0100

qubes-gui-agent (4.2.12-1) unstable; urgency=medium

  [ Marek Marczykowski-Górecki ]
  * ci: add job for running openQA directly from a PR
  * archlinux: drop pipewire<1:0.4 dependency
  * archlinux: drop pipewire<1:0.4 dependency, part 2

  [ fepitre-bot ]
  * Add pulseaudio-17.0 headers

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Wed, 24 Jan 2024 04:03:39 +0100

## qubes-gui-agent 4.2.13

=== debian/changelog ===
qubes-gui-agent (4.2.13-1+jammy1) jammy; urgency=medium

  * Build for jammy

 -- Builder <user@localhost>  Mon, 05 Feb 2024 04:46:50 +0100

qubes-gui-agent (4.2.13-1) unstable; urgency=medium

  [ Demi Marie Obenour ]
  * Add the PW_STREAM_MAP_BUFFERS flag
  * Add comments describing thread synchronization
  * Fix buffer size calculation error
  * Only use trace logs in the realtime thread
  * Obtain rate_match and position SPA IOs
  * Cleanup license metadata
  * Reduce usage of confusing 'direction' flag
  * Downgrade unknown ID errors to warnings
  * Fix error message when spa_format_parse() fails
  * Do not send QUBES_PA_SINK_UNCORK_CMD on overrun
  * Use a #define for the stream rate
  * Atomically send initial stream states
  * Avoid zeroing out recorded samples if underrun
  * Better error reporting
  * Allow capturing vchan size in one go
  * Use libvchan_send and libvchan_recv for all-or-nothing ops
  * Add utility program to run any PipeWire stream
  * Set node.rate for streams
  * Fix package descriptions
  * Drop support for PipeWire < 0.3.30
  * Do not rely on pw_context_get_support() on modern PipeWire
  * Avoid crashing during shutdown
  * Pass streams to stream callbacks
  * Fix audio quality problems

  [ Marek Marczykowski-Górecki ]
  * qubes-gui-runuser: fix parameters order for calloc

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Mon, 05 Feb 2024 04:46:50 +0100

## qubes-gui-agent 4.2.14

=== debian/changelog ===
qubes-gui-agent (4.2.14-1+jammy1) jammy; urgency=medium

  * Build for jammy

 -- Builder <user@localhost>  Fri, 26 Apr 2024 16:33:43 +0200

qubes-gui-agent (4.2.14-1) unstable; urgency=medium

  [ Marek Marczykowski-Górecki ]
  * rpm: fix conditional pipewire build

  [ Demi Marie Obenour ]
  * Clarify input vs output streams
  * Allow Qubes group to use all realtime priorities
  * Allow carriage return in secure clipboard

  [ Frédéric Pierret (fepitre) ]
  * Watch qdb entry being set and modified on start or while playing

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Fri, 26 Apr 2024 16:33:43 +0200

## qubes-gui-agent 4.2.15

=== debian/changelog ===
qubes-gui-agent (4.2.15-1+jammy1) jammy; urgency=medium

  * Build for jammy

 -- Builder <user@localhost>  Mon, 17 Jun 2024 04:28:10 +0200

qubes-gui-agent (4.2.15-1) unstable; urgency=medium

  * Fix missing glamoregl module in Xorg config for VNC GUIVM
  * Run x11vnc with correct SELinux context

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Mon, 17 Jun 2024 04:28:10 +0200

## qubes-gui-agent 4.2.16

=== debian/changelog ===
qubes-gui-agent (4.2.16-1+jammy1) jammy; urgency=medium

  * Build for jammy

 -- Builder <user@localhost>  Fri, 05 Jul 2024 17:27:00 +0200

qubes-gui-agent (4.2.16-1) unstable; urgency=medium

  [ Kamil Aronowski ]
  * Add xorg-xrandr dependence for vm-archlinux

  [ Ben Grande ]
  * Use software rendering for Gio apps by default

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Fri, 05 Jul 2024 17:27:00 +0200

## qubes-gui-agent 4.2.17

=== Makefile ===
#
# The Qubes OS Project, http://www.qubes-os.org
#
# Copyright (C) 2010  Joanna Rutkowska <joanna@invisiblethingslab.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
#

VERSION := $(file <version)
LIBDIR ?= /usr/lib64
USRLIBDIR ?= /usr/lib
SYSLIBDIR ?= /lib
XINITRCDIR ?= /etc/X11/xinit/xinitrc.d
LIMITSDIR ?= /etc/security/limits.d
UNITDIR ?= $(SYSLIBDIR)/systemd/system
USERUNITDIR ?= $(SYSLIBDIR)/systemd/user
USERPRESETDIR ?= $(SYSLIBDIR)/systemd/user-preset
UDEVRULESDIR ?= $(SYSLIBDIR)/udev/rules.d
DATADIR ?= /usr/share
PIPEWIRE_MODULES ?= $(LIBDIR)/pipewire-0.3
ifneq (,$(filter-out selinux install-selinux,$(MAKECMDGOALS)))
PA_VER_FULL ?= $(shell pkg-config --modversion libpulse | cut -d "-" -f 1 || echo 0.0)
PA_MODULE_DIR ?= $(shell pkg-config --variable=modlibexecdir libpulse)
endif

USER_DROPIN_DIR ?= /usr/lib/systemd/user

.PHONY: help
help:
	@echo "Qubes GUI main Makefile:" ;\
	    echo; \
	    echo "make clean                <--- clean all the binary files";\
	    exit 0;

.PHONY: appvm
appvm: gui-agent/qubes-gui gui-agent/qubes-gui-runuser \
	xf86-input-mfndev/src/.libs/qubes_drv.so \
	xf86-video-dummy/src/.libs/dummyqbs_drv.so pulse/module-vchan-sink.so \
	xf86-qubes-common/libxf86-qubes-common.so pipewire/qubes-pw-module.so

selinux_policies ::= qubes-gui-agent.pp
selinux: selinux/$(selinux_policies)
selinux/$(selinux_policies):
	$(MAKE) -C selinux -f /usr/share/selinux/devel/Makefile

.PHONY: install-selinux
install-selinux:
	install -D -t $(DESTDIR)/usr/share/selinux/packages selinux/$(selinux_policies)

gui-agent/qubes-gui gui-agent/qubes-gui-runuser:
	$(MAKE) -C gui-agent

xf86-input-mfndev/src/.libs/qubes_drv.so: xf86-qubes-common/libxf86-qubes-common.so
	(cd xf86-input-mfndev && ./autogen.sh && ./configure)
	$(MAKE) -C xf86-input-mfndev

xf86-video-dummy/src/.libs/dummyqbs_drv.so: xf86-qubes-common/libxf86-qubes-common.so
	(cd xf86-video-dummy && ./autogen.sh)
	$(MAKE) -C xf86-video-dummy

.PHONY: pulse/module-vchan-sink.so
pulse/module-vchan-sink.so:
	rm -f pulse/pulsecore
	ln -sf pulsecore-$(PA_VER_FULL) pulse/pulsecore
	$(MAKE) -C pulse module-vchan-sink.so

pipewire/qubes-pw-module.so:
	$(MAKE) -C pipewire qubes-pw-module.so

xf86-qubes-common/libxf86-qubes-common.so:
	$(MAKE) -C xf86-qubes-common libxf86-qubes-common.so

.PHONY: tar
tar:
	git archive --format=tar --prefix=qubes-gui/ HEAD -o qubes-gui.tar

.PHONY: clean
clean:
	(cd gui-agent && $(MAKE) clean)
	$(MAKE) -C pulse clean
	$(MAKE) -C xf86-qubes-common clean
	(cd xf86-input-mfndev; if [ -e Makefile ] ; then \
		$(MAKE) distclean; fi; ./bootstrap --clean || echo )
	rm -rf debian/changelog.*
	rm -rf pkgs

.PHONY: install
install: install-rh-agent install-pulseaudio install-pipewire

.PHONY: install-rh-agent
install-rh-agent: appvm install-common install-systemd
	install -m 0644 -D appvm-scripts/etc/sysconfig/desktop \
		$(DESTDIR)/etc/sysconfig/desktop
	install -D appvm-scripts/etc/X11/xinit/xinitrc.d/20qt-x11-no-mitshm.sh \
		$(DESTDIR)$(XINITRCDIR)/20qt-x11-no-mitshm.sh
	install -D appvm-scripts/etc/X11/xinit/xinitrc.d/20qt-gnome-desktop-session-id.sh \
		$(DESTDIR)$(XINITRCDIR)/20qt-gnome-desktop-session-id.sh
	install -D appvm-scripts/etc/X11/xinit/xinitrc.d/50guivm-windows-prefix.sh \
		$(DESTDIR)$(XINITRCDIR)/50guivm-windows-prefix.sh
	install -D appvm-scripts/etc/X11/xinit/xinitrc.d/60xfce-desktop.sh \
		$(DESTDIR)$(XINITRCDIR)/60xfce-desktop.sh

.PHONY: install-debian
install-debian: appvm install-common install-pulseaudio install-systemd install-pipewire
	install -d $(DESTDIR)/etc/X11/Xsession.d
	install -m 0644 appvm-scripts/etc/X11/Xsession.d/* $(DESTDIR)/etc/X11/Xsession.d/
	install -d $(DESTDIR)/etc/xdg
	install -m 0644 appvm-scripts/etc/xdg-debian/* $(DESTDIR)/etc/xdg

.PHONY: install-pulseaudio
install-pulseaudio:
	install -D pulse/start-pulseaudio-with-vchan \
		$(DESTDIR)/usr/bin/start-pulseaudio-with-vchan
	install -m 0644 -D pulse/qubes-default.pa \
		$(DESTDIR)/etc/pulse/qubes-default.pa
	install -D pulse/module-vchan-sink.so \
		$(DESTDIR)$(PA_MODULE_DIR)/module-vchan-sink.so
	install -m 0644 -D appvm-scripts/etc/tmpfiles.d/qubes-pulseaudio.conf \
		$(DESTDIR)$(USRLIBDIR)/tmpfiles.d/qubes-pulseaudio.conf
	install -m 0644 -D appvm-scripts/etc/xdgautostart/qubes-pulseaudio.desktop \
		$(DESTDIR)/etc/xdg/autostart/qubes-pulseaudio.desktop
	install -d $(DESTDIR)$(USER_DROPIN_DIR)/pulseaudio.service.d
	install -m 0644 pulse/pulseaudio.service.d/*.conf \
		$(DESTDIR)$(USER_DROPIN_DIR)/pulseaudio.service.d
	install -D -m 0644 pulse/75-pulseaudio-qubes.preset \
		$(DESTDIR)$(USER_DROPIN_DIR)-preset/75-pulseaudio-qubes.preset

.PHONY: install-pipewire
install-pipewire:
	install -m 0755 -D pipewire/qubes-pw-module.so \
		$(DESTDIR)$(PIPEWIRE_MODULES)/libpipewire-module-qubes.so
	install -m 0644 -D pipewire/30_qubes.conf \
		$(DESTDIR)$(DATADIR)/pipewire/pipewire.conf.d/30_qubes.conf
	install -m 0644 -D pipewire/COPYING \
		$(DESTDIR)$(DATADIR)/licenses/pipewire-qubes/COPYING
	install -m 0644 -D appvm-scripts/lib/systemd/user-preset/74-qubes-vm.preset \
		$(DESTDIR)$(USERPRESETDIR)/74-qubes-vm.preset
	install -d $(DESTDIR)/etc/qubes/post-install.d
	install -m 0755 appvm-scripts/etc/qubes/post-install.d/20-qubes-pipewire.sh \
                $(DESTDIR)/etc/qubes/post-install.d/20-qubes-pipewire.sh

.PHONY: install-systemd
install-systemd:
	install -m 0644 -D appvm-scripts/qubes-gui-agent.service \
		$(DESTDIR)$(UNITDIR)/qubes-gui-agent.service

.PHONY: install-common
install-common:
	install -D gui-agent/qubes-gui $(DESTDIR)/usr/bin/qubes-gui
	install -D gui-agent/qubes-gui-runuser $(DESTDIR)/usr/bin/qubes-gui-runuser
	install -d $(DESTDIR)/etc/qubes/post-install.d
	install -m 0755 appvm-scripts/etc/qubes/post-install.d/20-qubes-guivm-gui-agent.sh \
                $(DESTDIR)/etc/qubes/post-install.d/20-qubes-guivm-gui-agent.sh
	install -D appvm-scripts/usrbin/qubes-session \
		$(DESTDIR)/usr/bin/qubes-session
	install -D appvm-scripts/usrbin/qubes-run-xorg \
		$(DESTDIR)/usr/bin/qubes-run-xorg
	install -D appvm-scripts/usrbin/qubes-run-xephyr \
		$(DESTDIR)/usr/bin/qubes-run-xephyr
	install -D appvm-scripts/usrbin/qubes-start-xephyr \
		$(DESTDIR)/usr/bin/qubes-start-xephyr
	install -D appvm-scripts/usrbin/qubes-run-x11vnc \
		$(DESTDIR)/usr/bin/qubes-run-x11vnc
	install -D appvm-scripts/usrbin/qubes-change-keyboard-layout \
		$(DESTDIR)/usr/bin/qubes-change-keyboard-layout
	install -D appvm-scripts/usrbin/qubes-set-monitor-layout \
		$(DESTDIR)/usr/bin/qubes-set-monitor-layout
	install -D xf86-qubes-common/libxf86-qubes-common.so \
		$(DESTDIR)$(LIBDIR)/libxf86-qubes-common.so
	install -D xf86-input-mfndev/src/.libs/qubes_drv.so \
		$(DESTDIR)$(LIBDIR)/xorg/modules/drivers/qubes_drv.so
	install -D xf86-video-dummy/src/.libs/dummyqbs_drv.so \
		$(DESTDIR)$(LIBDIR)/xorg/modules/drivers/dummyqbs_drv.so
	install -m 0644 -D appvm-scripts/etc/X11/xorg-qubes.conf.template \
		$(DESTDIR)/etc/X11/xorg-qubes.conf.template
	install -m 0644 -D appvm-scripts/etc/X11/xorg-qubes-x11vnc.conf.template \
		$(DESTDIR)/etc/X11/xorg-qubes-x11vnc.conf.template
	install -m 0644 -D appvm-scripts/etc/systemd/system/lightdm.service.d/qubes-guivm-vnc.conf \
		$(DESTDIR)$(UNITDIR)/lightdm.service.d/qubes-guivm-vnc.conf
	install -m 0644 -D appvm-scripts/etc/profile.d/qubes-gui.sh \
		$(DESTDIR)/etc/profile.d/qubes-gui.sh
	install -m 0644 -D appvm-scripts/etc/profile.d/qubes-gui.csh \
		$(DESTDIR)/etc/profile.d/qubes-gui.csh
	install -m 0644 -D appvm-scripts/etc/securitylimits.d/90-qubes-gui.conf \
		$(DESTDIR)$(LIMITSDIR)/90-qubes-gui.conf
ifneq ($(shell lsb_release -is), Ubuntu)
	install -m 0644 -D appvm-scripts/etc/xdg/Trolltech.conf \
		$(DESTDIR)/etc/xdg/Trolltech.conf
endif
	install -m 0644 -D appvm-scripts/qubes-gui-vm.gschema.override \
		$(DESTDIR)$(DATADIR)/glib-2.0/schemas/20_qubes-gui-vm.gschema.override
	install -d $(DESTDIR)/etc/qubes-rpc
	ln -sf ../../usr/bin/qubes-set-monitor-layout \
		$(DESTDIR)/etc/qubes-rpc/qubes.SetMonitorLayout
	ln -sf ../../usr/bin/qubes-start-xephyr \
		$(DESTDIR)/etc/qubes-rpc/qubes.GuiVMSession
	install -D window-icon-updater/icon-sender \
		$(DESTDIR)/usr/lib/qubes/icon-sender
	install -m 0644 -D window-icon-updater/qubes-icon-sender.desktop \
		$(DESTDIR)/etc/xdg/autostart/qubes-icon-sender.desktop
	install -m 0644 -D appvm-scripts/etc/xdgautostart/qubes-qrexec-fork-server.desktop \
		$(DESTDIR)/etc/xdg/autostart/qubes-qrexec-fork-server.desktop
	install -m 0644 -D appvm-scripts/etc/xdgautostart/qubes-keymap.desktop \
		$(DESTDIR)/etc/xdg/autostart/qubes-keymap.desktop
	install -m 0644 -D appvm-scripts/etc/xdgautostart/qubes-gtk4-workarounds.desktop \
		$(DESTDIR)/etc/xdg/autostart/qubes-gtk4-workarounds.desktop
	install -D -m 0644 appvm-scripts/usr/lib/sysctl.d/30-qubes-gui-agent.conf \
		$(DESTDIR)/usr/lib/sysctl.d/30-qubes-gui-agent.conf
	install -D -m 0644 appvm-scripts/lib/udev/rules.d/70-master-of-seat.rules \
		$(DESTDIR)/$(UDEVRULESDIR)/70-master-of-seat.rules
	install -D -m 0644 appvm-scripts/lib/udev/rules.d/90-qubes-virtual-input-device.rules \
		$(DESTDIR)/$(UDEVRULESDIR)/90-qubes-virtual-input-device.rules
	install -D appvm-scripts/usr/lib/qubes/qubes-gui-agent-pre.sh \
		$(DESTDIR)/usr/lib/qubes/qubes-gui-agent-pre.sh
	install -D appvm-scripts/usr/lib/qubes/qubes-keymap.sh \
		$(DESTDIR)/usr/lib/qubes/qubes-keymap.sh
	install -D appvm-scripts/usr/lib/qubes/qubes-xorg-wrapper \
		$(DESTDIR)/usr/lib/qubes/qubes-xorg-wrapper
	install -D appvm-scripts/usr/lib/qubes/gtk4-workarounds.sh \
		$(DESTDIR)/usr/lib/qubes/gtk4-workarounds.sh
ifeq ($(shell lsb_release -is), Debian)
	install -D -m 0644 appvm-scripts/etc/pam.d/qubes-gui-agent.debian \
		$(DESTDIR)/etc/pam.d/qubes-gui-agent
else ifeq ($(shell lsb_release -is), Ubuntu)
	install -D -m 0644 appvm-scripts/etc/pam.d/qubes-gui-agent.debian \
		$(DESTDIR)/etc/pam.d/qubes-gui-agent
else ifeq ($(shell lsb_release -is), Arch)
	install -D -m 0644 appvm-scripts/etc/pam.d/qubes-gui-agent.archlinux \
		$(DESTDIR)/etc/pam.d/qubes-gui-agent
else ifeq ($(shell lsb_release -is), Gentoo)
	install -D -m 0644 appvm-scripts/etc/pam.d/qubes-gui-agent.gentoo \
		$(DESTDIR)/etc/pam.d/qubes-gui-agent
else
	install -D -m 0644 appvm-scripts/etc/pam.d/qubes-gui-agent \
		$(DESTDIR)/etc/pam.d/qubes-gui-agent
endif
	install -d $(DESTDIR)/var/log/qubes

=== gui-agent/Makefile ===
#
# The Qubes OS Project, http://www.qubes-os.org
#
# Copyright (C) 2010  Rafal Wojtczuk  <rafal@invisiblethingslab.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
#

CC ?= gcc
CFLAGS += -I../include/ `pkg-config --cflags vchan` -g -Wall -Wextra -Werror -fPIC \
	  -Wmissing-prototypes -Wstrict-prototypes -Wold-style-declaration \
	  -Wold-style-definition
OBJS = vmside.o txrx-vchan.o error.o list.o encoding.o
LIBS = -lX11 -lXdamage -lXcomposite -lXfixes `pkg-config --libs vchan` -lqubesdb


all: qubes-gui qubes-gui-runuser
qubes-gui: $(OBJS)
	$(CC) $(LDFLAGS) -pie -g -o qubes-gui $(OBJS) \
		$(LIBS)
qubes-gui-runuser: CFLAGS += -g -Wall -Wextra -Werror -pie -fPIC
qubes-gui-runuser: LDLIBS += -lpam -lqubesdb
qubes-gui-runuser: qubes-gui-runuser.c
clean:
	rm -f qubes-gui qubes-gui-runuser ./*.o ./*~

=== pipewire/Makefile ===
--- 
+++ 
@@ -6,15 +6,19 @@
 CFLAGS += $(extra_cflags)
 LDLIBS += $(extra_ldflags)
 LDFLAGS += -ggdb -Wl,--no-as-needed,--no-allow-shlib-undefined,-z,relro,-z,now
-qubes-pw-module.so: build/qubes-pw-module.o | Makefile
+all: qubes-pw-module.so pw-module-run
+%.so: build/%.o | Makefile
 	@mkdir -p -m 0700 -- build
 	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ -shared $(LDLIBS)
+%: build/%.o | Makefile
+	@mkdir -p -m 0700 -- build
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LDLIBS)
 
 build/%.o: %.c Makefile
 	@mkdir -p -m 0700 -- build
 	$(CC) $(CPPFLAGS) $(CFLAGS) -c -o $@ $< -MP -MD -MF $@.dep
 
-.PHONY: clean
+.PHONY: clean all .PHONY
 clean:
 	rm -rf -- build
 -include build/*.o.dep

=== pulse/Makefile ===
CC=gcc
CFLAGS+=-Wall -Wextra -Werror -O2
LIBS=-lqubesdb
VCHANLIBS=`pkg-config --libs vchan`
VCHANCFLAGS=`pkg-config --cflags vchan`
GLIBCFLAGS=`pkg-config --cflags glib-2.0` `pkg-config --cflags dbus-glib-1`
GLIBLIBS=`pkg-config --libs glib-2.0` `pkg-config --libs dbus-glib-1` `pkg-config --libs gthread-2.0`
LIBPULSE_VERSION=$(shell pkg-config --modversion libpulse)
all: module-vchan-sink.so
module-vchan-sink.so: module-vchan-sink.o
	$(CC) -shared -o module-vchan-sink.so module-vchan-sink.o \
		$(VCHANLIBS) $(LIBS)
module-vchan-sink.o: module-vchan-sink.c
	$(CC) $(CFLAGS) -g -c $(VCHANCFLAGS) -fPIC module-vchan-sink.c  -DHAVE_CONFIG_H -DHAVE_QUBESDB_CLIENT_H -DLIBPULSE_VERSION='"$(LIBPULSE_VERSION)"' -I.
clean:
	rm -f *.so *.o *~

=== debian/changelog ===
qubes-gui-agent (4.2.17-1+jammy1) jammy; urgency=medium

  * Build for jammy

 -- Builder <user@localhost>  Tue, 30 Jul 2024 21:25:42 +0200

qubes-gui-agent (4.2.17-1) unstable; urgency=medium

  [ Marek Marczykowski-Górecki ]
  * Prevent xfsettingsd re-enabling key auto-repeat feature

  [ Simon Gaiser ]
  * xf86-input-mfndev: Block generation of key repeat events

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 30 Jul 2024 21:25:42 +0200

## qubes-gui-agent 4.2.18

=== debian/changelog ===
qubes-gui-agent (4.2.18-1+jammy1) jammy; urgency=medium

  * Build for jammy

 -- Builder <user@localhost>  Sat, 24 Aug 2024 02:38:30 +0200

qubes-gui-agent (4.2.18-1) unstable; urgency=medium

  * Fix input device labels

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sat, 24 Aug 2024 02:38:30 +0200

## qubes-gui-agent 4.2.19

=== debian/changelog ===
qubes-gui-agent (4.2.19-1+noble1) noble; urgency=medium

  * Build for noble

 -- Builder <user@localhost>  Fri, 08 Nov 2024 02:33:54 +0100

qubes-gui-agent (4.2.19-1) unstable; urgency=medium

  * rpm: depend on cvt in F41+

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Fri, 08 Nov 2024 02:33:54 +0100

## qubes-gui-agent 4.2.20

=== debian/changelog ===
qubes-gui-agent (4.2.20-1+noble1) noble; urgency=medium

  * Build for noble

 -- Builder <user@localhost>  Fri, 27 Dec 2024 03:04:30 +0100

qubes-gui-agent (4.2.20-1) unstable; urgency=medium

  [ Marek Marczykowski-Górecki ]
  * Move signal registraion earlier
  * Better handle premature Xorg exit
  * Fix logging in xf86-input-mfndev
  * pipewire: prevent starting in root session
  * xf86-input-mfndev: interrupt attempts to contact gui-agent on
    SIGTERM

  [ Rusty Bird ]
  * Also set software rendering via the new $GDK_DISABLE variable

  [ Marek Marczykowski-Górecki ]
  * archlinux: update pulseaudio dependency

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Fri, 27 Dec 2024 03:04:30 +0100

## qubes-gui-agent 4.2.21

=== debian/changelog ===
qubes-gui-agent (4.2.21-1+jammy1) jammy; urgency=medium

  * Build for jammy

 -- Builder <user@localhost>  Fri, 06 Jun 2025 05:17:23 +0200

qubes-gui-agent (4.2.21-1) unstable; urgency=medium

  [ Marek Marczykowski-Górecki ]
  * xf86-video-dummy: fix type of CreateWindow field
  * Format commands .qubesbuilder in single quotes

  [ degletnour ]
  * updated broken gui docs link

  [ Marek Marczykowski-Górecki ]
  * Add error checking on input device init

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Fri, 06 Jun 2025 05:17:23 +0200

=== debian/control ===
--- 
+++ 
@@ -50,7 +50,7 @@
     xserver-xorg-input-qubes (= ${binary:Version}),
     ${shlibs:Depends},
     ${misc:Depends}
-Recommends: qt4-qtconfig, pipewire-qubes
+Recommends: qt4-qtconfig, pulseaudio-qubes
 Provides: x-display-manager
 Description: Makes X11 windows available to qubes dom0
  The Qubes GUI agent allows the forwarding of running app windows to the
@@ -121,10 +121,10 @@
 Conflicts: pulseaudio-qubes
 Recommends: pipewire-pulse
 Description: PipeWire module to enable sound support in Qubes VM
- Experimental PipeWire module to enable sound support in Qubes VMs.
- Unlike the PulseAudio support in the pulseaudio-qubes package, this
- works with the stock PipeWire service and does not depend on internal
- PipeWire headers.  It is also less code.
+ PipeWire module to enable sound support in Qubes VMs.  Unlike the
+ PulseAudio support in the pulseaudio-qubes package, this works with
+ the stock PipeWire service and does not depend on internal
+ PipeWire headers.
 
 Package: qubes-gui-agent-xfce
 Architecture: any

## qubes-gui-agent 4.2.22

=== Makefile ===
--- 
+++ 
@@ -151,6 +151,10 @@
 	install -d $(DESTDIR)/etc/qubes/post-install.d
 	install -m 0755 appvm-scripts/etc/qubes/post-install.d/20-qubes-pipewire.sh \
                 $(DESTDIR)/etc/qubes/post-install.d/20-qubes-pipewire.sh
+	install -d $(DESTDIR)$(USERUNITDIR)/pipewire.service.d
+	install -m 0644 appvm-scripts/lib/systemd/user/pipewire.service.d/30_qubes.conf \
+		$(DESTDIR)$(USERUNITDIR)/pipewire.service.d/30_qubes.conf
+
 
 .PHONY: install-systemd
 install-systemd:

=== debian/changelog ===
qubes-gui-agent (4.2.22-1+deb13u1) trixie; urgency=medium

  * Build for trixie

 -- Builder <user@localhost>  Fri, 09 Jan 2026 13:46:19 +0100

qubes-gui-agent (4.2.22-1) unstable; urgency=medium

  [ Marek Marczykowski-Górecki ]
  * Remove '$env' after it's loaded into environment
  * Include 'pointer' in the qubes input device name

  [ Simon Gaiser ]
  * vmside: Use correct format string instead of casting part 2

  [ Vertex X7-53 ]
  * Unbind Xen VGA adapter from bochs-drm on boot

  [ Marek Marczykowski-Górecki ]
  * Avoid using lspci in qubes-gui-agent-pre.sh
  * archlinux: relax libpulse dependency
  * debian: install cvt tool
  * archlinux: relax runtime pulseaudio dependency too

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Fri, 09 Jan 2026 13:46:19 +0100

=== debian/control ===
--- 
+++ 
@@ -46,11 +46,12 @@
     libpam-systemd,
     python3,
     python3-xcffib,
+    xcvt,
     xserver-xorg-video-dummyqbs (= ${binary:Version}),
     xserver-xorg-input-qubes (= ${binary:Version}),
     ${shlibs:Depends},
     ${misc:Depends}
-Recommends: qt4-qtconfig, pulseaudio-qubes
+Recommends: qt4-qtconfig, pipewire-qubes
 Provides: x-display-manager
 Description: Makes X11 windows available to qubes dom0
  The Qubes GUI agent allows the forwarding of running app windows to the

## qubes-gui-agent 4.3.0

=== debian/changelog ===
qubes-gui-agent (4.3.0-1+jammy1) jammy; urgency=medium

  * Build for jammy

 -- Builder <user@localhost>  Sun, 27 Oct 2024 04:32:31 +0100

qubes-gui-agent (4.3.0-1) unstable; urgency=medium

  [ Ali Mirjamali ]
  * Handle oversized clipboard for GUI protocol 1.8
  * Switching CI to R4.3

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sun, 27 Oct 2024 04:32:31 +0100

## qubes-gui-agent 4.3.1

=== debian/changelog ===
qubes-gui-agent (4.3.1-1+jammy1) jammy; urgency=medium

  * Build for jammy

 -- Builder <user@localhost>  Fri, 08 Nov 2024 02:33:02 +0100

qubes-gui-agent (4.3.1-1) unstable; urgency=medium

  [ Marek Marczykowski-Górecki ]
  * Bump required qubes-gui-common version

  [ Demi Marie Obenour ]
  * Use the drained callback on the playback stream

  [ Marek Marczykowski-Górecki ]
  * rpm: depend on cvt in F41+

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Fri, 08 Nov 2024 02:33:02 +0100

## qubes-gui-agent 4.3.2

=== debian/changelog ===
qubes-gui-agent (4.3.2-1+noble1) noble; urgency=medium

  * Build for noble

 -- Builder <user@localhost>  Tue, 10 Dec 2024 19:21:06 +0100

qubes-gui-agent (4.3.2-1) unstable; urgency=medium

  * pipewire: prevent starting in root session
  * Move signal registraion earlier
  * Better handle premature Xorg exit
  * Fix logging in xf86-input-mfndev
  * xf86-input-mfndev: interrupt attempts to contact gui-agent on
    SIGTERM

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 10 Dec 2024 19:21:06 +0100

## qubes-gui-agent 4.3.3

=== debian/changelog ===
qubes-gui-agent (4.3.3-1+noble1) noble; urgency=medium

  * Build for noble

 -- Builder <user@localhost>  Fri, 27 Dec 2024 01:24:25 +0100

qubes-gui-agent (4.3.3-1) unstable; urgency=medium

  * archlinux: update pulseaudio dependency
  * archlinux: make qubes-vm-pipewire replace qubes-vm-pulseaudio

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Fri, 27 Dec 2024 01:24:25 +0100

## qubes-gui-agent 4.3.4

=== debian/changelog ===
qubes-gui-agent (4.3.4-1+deb13u1) trixie; urgency=medium

  * Build for trixie

 -- Builder <user@localhost>  Fri, 27 Dec 2024 01:56:27 +0100

qubes-gui-agent (4.3.4-1) unstable; urgency=medium

  [ Rusty Bird ]
  * Also set software rendering via the new $GDK_DISABLE variable

  [ Guillaume Chinal ]
  * disable qubes-icon-sender on sys-net and sys-usb Qubes icon sender
    allows to update applications windows icons. In practice, few
    windows are opened on the sys-vms. Disabling this service allows to
    recover some RAM without causing inconvenience

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Fri, 27 Dec 2024 01:56:27 +0100

=== debian/control ===
--- 
+++ 
@@ -22,7 +22,7 @@
     lsb-release,
     libpipewire-0.3-dev,
     quilt,
-    qubes-gui-common (>= 4.1.0),
+    qubes-gui-common (>= 4.3.0),
     qubesdb-dev,
     libltdl-dev,
 Standards-Version: 4.4.0.1
@@ -46,7 +46,6 @@
     libpam-systemd,
     python3,
     python3-xcffib,
-    xcvt,
     xserver-xorg-video-dummyqbs (= ${binary:Version}),
     xserver-xorg-input-qubes (= ${binary:Version}),
     ${shlibs:Depends},

## qubes-gui-agent 4.3.5

=== debian/changelog ===
qubes-gui-agent (4.3.5-1+noble1) noble; urgency=medium

  * Build for noble

 -- Builder <user@localhost>  Sun, 26 Jan 2025 18:59:56 +0100

qubes-gui-agent (4.3.5-1) unstable; urgency=medium

  [ Ali Mirjamali ]
  * Pull in required Pipewire dependencies for Archlinux

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sun, 26 Jan 2025 18:59:56 +0100

=== debian/control ===
--- 
+++ 
@@ -50,7 +50,7 @@
     xserver-xorg-input-qubes (= ${binary:Version}),
     ${shlibs:Depends},
     ${misc:Depends}
-Recommends: qt4-qtconfig, pipewire-qubes
+Recommends: qt4-qtconfig, pulseaudio-qubes
 Provides: x-display-manager
 Description: Makes X11 windows available to qubes dom0
  The Qubes GUI agent allows the forwarding of running app windows to the

## qubes-gui-agent 4.3.6

=== debian/changelog ===
qubes-gui-agent (4.3.6-1+noble1) noble; urgency=medium

  * Build for noble

 -- Builder <user@localhost>  Thu, 27 Feb 2025 03:35:15 +0100

qubes-gui-agent (4.3.6-1) unstable; urgency=medium

  * xf86-video-dummy: fix type of CreateWindow field

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Thu, 27 Feb 2025 03:35:15 +0100

## qubes-gui-agent 4.3.7

=== debian/changelog ===
qubes-gui-agent (4.3.7-1+noble1) noble; urgency=medium

  * Build for noble

 -- Builder <user@localhost>  Thu, 12 Jun 2025 11:25:34 +0200

qubes-gui-agent (4.3.7-1) unstable; urgency=medium

  [ Marek Marczykowski-Górecki ]
  * rpm: update pulseaudio dep in openSUSE variant too
  * rpm: include BR: pkgconfig(systemd) explicitly
  * rpm: add BR: pkgconfig
  * rpm: allow BR: systemd-mini on openSUSE too
  * rpm: add missing directory ownership
  * Format commands .qubesbuilder in single quotes

  [ degletnour ]
  * updated broken gui docs link

  [ Marek Marczykowski-Górecki ]
  * Correctly label pointing device as absolute, not relative
  * Add error checking on input device init

  [ Ali Mirjamali ]
  * Send icons for legacy X11 Apps
  * Rewrite legacy X11 App icons extraction in xcffib
  * Change end of trimmed long window titles to U+2026

  [ Marek Marczykowski-Górecki ]
  * Do not allocate grants for framebuffer by default
  * Drop DGA extension support
  * Increase screen pixmap size beyond initial video RAM if needed

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Thu, 12 Jun 2025 11:25:34 +0200

## qubes-gui-agent 4.3.8

=== debian/changelog ===
qubes-gui-agent (4.3.8-1+noble1) noble; urgency=medium

  * Build for noble

 -- Builder <user@localhost>  Mon, 23 Jun 2025 01:59:35 +0200

qubes-gui-agent (4.3.8-1) unstable; urgency=medium

  * Remove '$env' after it's loaded into environment
  * Include 'pointer' in the qubes input device name
  * Revert "Use the drained callback on the playback stream"

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Mon, 23 Jun 2025 01:59:35 +0200

## qubes-gui-agent 4.3.9

=== debian/changelog ===
qubes-gui-agent (4.3.9-1+noble1) noble; urgency=medium

  * Build for noble

 -- Builder <user@localhost>  Sun, 20 Jul 2025 17:11:33 +0200

qubes-gui-agent (4.3.9-1) unstable; urgency=medium

  [ Simon Gaiser ]
  * Cleanup sockaddr_un generation
  * vmside: Use correct format string instead of casting
  * vmside: Always print error to stderr
  * vmside: cleanup window lookup
  * vmside: cleanup logging
  * vmside: remove trailing whitespace
  * xf86-video-dummy: remove trailing whitespace
  * vmside: Fix oddly formatted comments
  * vmside: Remove tabs
  * xf86-video-dummy: Remove tabs
  * Don't try to send grants for not realized windows

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sun, 20 Jul 2025 17:11:33 +0200

## qubes-gui-agent 4.3.10

=== debian/changelog ===
qubes-gui-agent (4.3.10-1+noble1) noble; urgency=medium

  * Build for noble

 -- Builder <user@localhost>  Thu, 07 Aug 2025 03:10:40 +0200

qubes-gui-agent (4.3.10-1) unstable; urgency=medium

  [ Simon Gaiser ]
  * vmside: Use correct format string instead of casting part 2
  * xf86-video-dummy: codestyle: avoid unnecessary indent

  [ Marcus Ofenhed ]
  * Fixed ignored X property NET_WM_STATE_HIDDEN

  [ Demi Marie Obenour ]
  * pipewire: Use recommended driver and session priorities

  [ Marek Marczykowski-Górecki ]
  * Revert "Don't try to send grants for not realized windows"

  [ Simon Gaiser ]
  * Don't try to send grants for not realized windows

  [ Vertex X7-53 ]
  * Unbind Xen VGA adapter from bochs-drm on boot

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Thu, 07 Aug 2025 03:10:40 +0200

## qubes-gui-agent 4.3.11

=== debian/changelog ===
qubes-gui-agent (4.3.11-1+jammy1) jammy; urgency=medium

  * Build for jammy

 -- Builder <user@localhost>  Thu, 18 Sep 2025 04:53:39 +0200

qubes-gui-agent (4.3.11-1) unstable; urgency=medium

  * Avoid using lspci in qubes-gui-agent-pre.sh

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Thu, 18 Sep 2025 04:53:39 +0200

=== debian/control ===
--- 
+++ 
@@ -25,6 +25,7 @@
     qubes-gui-common (>= 4.3.0),
     qubesdb-dev,
     libltdl-dev,
+    libunistring-dev,
 Standards-Version: 4.4.0.1
 Homepage: http://www.qubes-os.org/
 #Vcs-Git: git://git.debian.org/collab-maint/qubes-gui-agent.git

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+fixfilepath
DPKG_EXPORT_BUILDFLAGS = 1

include /usr/share/dpkg/default.mk
export DESTDIR=$(shell pwd)/debian/tmp
export LIBDIR=/usr/lib
export PIPEWIRE_MODULES=/usr/lib/$(DEB_HOST_MULTIARCH)/pipewire-0.3

PA_VER=$(shell pkg-config --modversion libpulse | cut -d "-" -f 1 || echo 0.0)

%:
	dh $@ --with systemd,xsf

override_dh_auto_build:
	make appvm

override_dh_auto_install:
	make install-debian

override_dh_systemd_start:
	dh_systemd_start --no-restart-after-upgrade --no-restart-on-upgrade

override_dh_install:
	dh_install

override_dh_missing:
	dh_missing --fail-missing

override_dh_installsystemduser:
	dh_installsystemduser pipewire.socket pipewire-pulse.socket pipewire.service pipewire-pulse.service wireplumber.service

override_dh_gencontrol:
	echo "pulse:Depends=pulseaudio (>= 1:$(PA_VER)), pulseaudio (<< 1:$(PA_VER).1)" >> debian/pulseaudio-qubes.substvars
	dh_gencontrol

## qubes-gui-agent 4.3.12

=== debian/changelog ===
qubes-gui-agent (4.3.12-1+jammy1) jammy; urgency=medium

  * Build for jammy

 -- Builder <user@localhost>  Mon, 20 Oct 2025 20:03:20 +0200

qubes-gui-agent (4.3.12-1) unstable; urgency=medium

  [ Marek Marczykowski-Górecki ]
  * archlinux: bump pulseaudio version

  [ Aaron Rainbolt ]
  * qubes-gui-runner: get environment from systemd user instance and
    pass it through to the session

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Mon, 20 Oct 2025 20:03:20 +0200

=== debian/control ===
--- 
+++ 
@@ -26,6 +26,7 @@
     qubesdb-dev,
     libltdl-dev,
     libunistring-dev,
+    libdbus-1-dev,
 Standards-Version: 4.4.0.1
 Homepage: http://www.qubes-os.org/
 #Vcs-Git: git://git.debian.org/collab-maint/qubes-gui-agent.git

## qubes-gui-agent 4.3.13

=== debian/changelog ===
qubes-gui-agent (4.3.13-1+deb13u1) trixie; urgency=medium

  * Build for trixie

 -- Builder <user@localhost>  Wed, 05 Nov 2025 15:43:01 +0100

qubes-gui-agent (4.3.13-1) unstable; urgency=medium

  [ Ali Mirjamali ]
  * Do not exclude 256x256 icons from icon-sender

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Wed, 05 Nov 2025 15:43:01 +0100

=== debian/control ===
--- 
+++ 
@@ -52,7 +52,7 @@
     xserver-xorg-input-qubes (= ${binary:Version}),
     ${shlibs:Depends},
     ${misc:Depends}
-Recommends: qt4-qtconfig, pulseaudio-qubes
+Recommends: qt4-qtconfig, pipewire-qubes
 Provides: x-display-manager
 Description: Makes X11 windows available to qubes dom0
  The Qubes GUI agent allows the forwarding of running app windows to the

## qubes-gui-agent 4.3.14

=== debian/changelog ===
qubes-gui-agent (4.3.14-1+noble1) noble; urgency=medium

  * Build for noble

 -- Builder <user@localhost>  Sat, 15 Nov 2025 14:55:14 +0100

qubes-gui-agent (4.3.14-1) unstable; urgency=medium

  [ Marek Marczykowski-Górecki ]
  * archlinux: relax libpulse dependency

  [ Ali Mirjamali ]
  * Send optimized icon size

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sat, 15 Nov 2025 14:55:14 +0100
